const util = require("util")
  , fs = require("fs")
  , ytdl = require("youtube-dl");

const _args = [
  "--no-progress",
  "--no-warnings",
  "--no-check-certificate",
  //"--max-filesize 500m",
  '-o "./tmp/%(title)s.%(ext)s"'
];


module.exports = bot => {
  bot._trigger.set("parser", {
    call: /https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi,
    level: 0,
    active: true,
    clients: ["irc"],
    f: e => {
      if(e.network === "n0xy" && e.channel === "#kbot-dev") {
        const links = e.message.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi);
        Promise.all(links.map(link => checkRepost(link))) // repostcheck
          .then(res => Promise.all(res.map(link => ytdl_info(link, _args)))) // info holen
          .then(
            res => Promise.all(res.map(t => { e.reply(t.res); return t.link; })),
            err => Promise.all(err.map(t => { e.reply(t.err); return t.link; }))
          )
          .then(link => {
            e.reply(`link: ${link}`);
          });
      }
    }
  });
};

function checkRepost(link) {
  return new Promise((resolve, reject) => {
    resolve(link);
  });
}

function ytdl_info(link, args) {
  return new Promise((resolve, reject) => {
    ytdl.getInfo(link, args, (err, res) => {
      if(err) reject({ link: link, err: err });
      if(res) resolve({ link: link, res: res });
    });
  });
}